2016-12-30 19:06:44 +00:00
#! /bin/bash
2016-06-14 11:16:11 +00:00
2021-02-14 20:19:58 +00:00
# shellcheck disable=SC2094
2020-10-21 16:16:32 +00:00
# ? This is done to ignore the message "Make sure not to read and write
# ? the same file in the same pipeline", which is a result of ${DATABASE}
# ? being used below. (This disables the message file-wide.)
2021-01-16 09:16:05 +00:00
# shellcheck source=../scripts/helper-functions.sh
. /usr/local/bin/helper-functions.sh
2020-10-21 16:16:32 +00:00
2016-12-30 19:06:44 +00:00
DATABASE=${DATABASE:-/tmp/docker-mailserver/postfix-accounts.cf}
2018-03-14 19:00:38 +00:00
ALIAS_DATABASE="/tmp/docker-mailserver/postfix-virtual.cf"
2020-04-24 12:55:32 +00:00
QUOTA_DATABASE="/tmp/docker-mailserver/dovecot-quotas.cf"
2021-02-14 20:19:58 +00:00
MAILDEL=false
2016-12-30 19:06:44 +00:00
2021-02-17 11:12:51 +00:00
function __usage
2020-10-21 16:16:32 +00:00
{
2021-02-17 11:12:51 +00:00
echo -e "\e[35mDELMAILUSER\e[31m(\e[93m8\e[31m)
\e[38;5;214mNAME\e[39m
delmailuser - delete a user and related data
\e[38;5;214mSYNOPSIS\e[39m
./setup.sh email del [ OPTIONS ] { <MAIL ADDRESS> [<MAIL ADDRESS 2>\e[31m...\e[39m] \e[31m|\e[39m help }
\e[38;5;214mDESCRIPTION\e[39m
Delete a mail user, aliases, quotas and mail data.
\e[38;5;214mOPTIONS\e[39m
-y
Indicate that \e[1mall mail data\e[22m is to be deleted without another prompt.
-h
Show this help dialogue.
\e[38;5;214mEXAMPLES\e[39m
./setup.sh email del -y test@domain.com another-test@domain.com
Delete all mail data for the users 'test' and 'another-test'
and do not prompt to ask if all mail data should be deleted.
./setup.sh email del woohoo@some-domain.org
Delete the mail user, quotas and aliases, but ask again whether
mailbox data should be deleted.
\e[38;5;214mEXIT STATUS\e[39m
Exit status is 0 if command was successful, and 1 if there was an error.
"
2016-12-30 19:06:44 +00:00
}
2021-02-17 11:12:51 +00:00
if [[ ${1} == 'help' ]]
then
__usage
exit 0
fi
while getopts ":yYh" OPT
2020-10-21 16:16:32 +00:00
do
case ${OPT} in
2021-02-14 20:19:58 +00:00
y | Y )
MAILDEL=true
2020-10-21 16:16:32 +00:00
;;
2021-02-17 11:12:51 +00:00
h )
__usage
exit 0
;;
2021-02-14 20:19:58 +00:00
* )
2021-02-17 11:12:51 +00:00
__usage
echo "The option ${OPT} is unknown." >&2
2021-02-14 20:19:58 +00:00
exit 1
2020-10-21 16:16:32 +00:00
;;
2021-02-17 11:12:51 +00:00
2018-03-14 19:00:38 +00:00
esac
done
shift $((OPTIND-1))
2020-10-21 16:16:32 +00:00
[[ -z ${*} ]] && { usage ; errex "No user specifed" ; }
[[ -s ${DATABASE} ]] || exit 0
2016-12-30 19:06:44 +00:00
2021-02-14 20:19:58 +00:00
if ! ${MAILDEL}
then
read -r -p "Do you want to delete the mailbox as well (removing all mails) ? [Y/n] " MAILDEL_CHOSEN
2021-02-17 11:12:51 +00:00
if [[ ${MAILDEL_CHOSEN} =~ (y|Y|yes|Yes) ]] || [[ -z ${MAILDEL_CHOSEN} ]]
then
MAILDEL=true
fi
2021-02-14 20:19:58 +00:00
fi
2019-08-01 17:39:25 +00:00
(
flock -e 200
2021-02-17 11:12:51 +00:00
ERROR=false
2019-08-01 17:39:25 +00:00
2020-10-21 16:16:32 +00:00
for USER in "${@}"
do
2019-08-01 17:39:25 +00:00
# very simple plausibility check
2021-02-14 20:19:58 +00:00
[[ ${USER} != *'@'*'.'* ]] && errex "No valid address: ${USER}"
2020-10-21 16:16:32 +00:00
declare -a MAILARR
MAILARR[0]="${USER%@*}"
MAILARR[1]="${USER#*@}"
2021-02-14 20:19:58 +00:00
# ${USER} must not contain /s and other syntactic characters
2021-02-17 11:12:51 +00:00
UNESCAPED_USER="${USER}"
2020-10-21 16:16:32 +00:00
USER=$(escape "${USER}")
2021-02-14 20:19:58 +00:00
if [[ -f ${DATABASE} ]]
2020-10-21 16:16:32 +00:00
then
2021-02-14 20:19:58 +00:00
if ! sed -i "/^${USER}|/d" "${DATABASE}"
then
2021-02-17 11:12:51 +00:00
echo "${UNESCAPED_USER} couldn't be deleted in ${DATABASE}." >&2
ERROR=true
2021-02-14 20:19:58 +00:00
fi
2020-10-21 16:16:32 +00:00
fi
2021-02-14 20:19:58 +00:00
if [[ -f ${ALIAS_DATABASE} ]]
2020-10-21 16:16:32 +00:00
then
2021-02-14 20:19:58 +00:00
# delete all aliases where the user is the only recipient( " ${USER$}" )
# delete user only for all aliases that deliver to multiple recipients ( ",${USER}" "${USER,}" )
if sed -i \
-e "/ ${USER}$/d" -e "s/,${USER}//g" -e "s/${USER},//g" \
"${ALIAS_DATABASE}"
then
2021-02-17 11:12:51 +00:00
echo "${UNESCAPED_USER} and potential aliases deleted."
2021-02-14 20:19:58 +00:00
else
2021-02-17 11:12:51 +00:00
echo "Aliases for ${UNESCAPED_USER} couldn't be deleted in ${ALIAS_DATABASE}." >&2
ERROR=true
2021-02-14 20:19:58 +00:00
fi
2020-10-21 16:16:32 +00:00
fi
2020-04-24 12:55:32 +00:00
# remove quota directives
2020-10-21 16:16:32 +00:00
if [[ -f ${QUOTA_DATABASE} ]]
then
2021-02-14 20:19:58 +00:00
if ! sed -i -e "/^${USER}:.*$/d" "${QUOTA_DATABASE}"
then
2021-02-17 11:12:51 +00:00
echo "Quota for ${UNESCAPED_USER} couldn't be deleted in ${QUOTA_DATABASE}." >&2
2021-02-14 20:19:58 +00:00
fi
2020-04-24 12:55:32 +00:00
fi
2021-02-14 20:19:58 +00:00
if ! ${MAILDEL}
2020-10-21 16:16:32 +00:00
then
2021-02-14 20:19:58 +00:00
echo "Leaving the mailbox untouched. If you want to delete it at a later point use 'sudo docker exec mail rm -R /var/mail/${MAILARR[1]}/${MAILARR[0]}'"
exit 0
2019-08-01 17:39:25 +00:00
fi
2020-10-21 16:16:32 +00:00
2021-02-17 11:12:51 +00:00
if [[ -e "/var/mail/${MAILARR[1]}/${MAILARR[0]}" ]]
2020-10-21 16:16:32 +00:00
then
2021-02-17 11:12:51 +00:00
if rm -R "/var/mail/${MAILARR[1]}/${MAILARR[0]}"
2021-02-14 20:19:58 +00:00
then
echo "Mailbox deleted."
else
2021-02-17 11:12:51 +00:00
echo "Mailbox couldn't be deleted." >&2
ERROR=true
2021-02-14 20:19:58 +00:00
fi
else
2021-02-17 11:12:51 +00:00
echo "Mailbox directory '/var/mail/${MAILARR[1]}/${MAILARR[0]}' did not exist." >&2
ERROR=true
2020-10-21 16:16:32 +00:00
fi
2019-08-01 17:39:25 +00:00
done
2021-02-17 11:12:51 +00:00
${ERROR} && errex 'Errors encountered.'
2020-10-21 16:16:32 +00:00
) 200< "${DATABASE}"
2021-02-17 11:12:51 +00:00
exit 0